#pragma once
#include "game_data.h"
#include "UIAbstract.h"
#include "NSText.h"
#include "NSLockpicking.h"
#include "Text-Based_RPG.h"

char action_buffer[100] = "";

UIAbstract *executeAction(int actionId)
{
    byte r;
    switch (actionId)
    {
    case ACTION_HEAL:
        player.replenish(10, 0);
        return nullptr;
    case ACTION_BUY:
        ++player.lockpicks;
        return nullptr;
    case ACTION_GRASSLANDS:
        r = random(1, 6);
        player.replenish(r, 0);
        sprintf(action_buffer, "Grasslands: You have regained %d health!", r);
        return new NSText::UI(action_buffer);
    case ACTION_RIVER:
        r = random(1, 6);
        player.replenish(0, r);
        sprintf(action_buffer, "River: You have regained %d mana!", r);
        return new NSText::UI(action_buffer);
    case ACTION_MOUNTAIN:
        r = random(5, 21);
        player.replenish(-r, 0);
        sprintf(action_buffer, "Mountain: You have lost %d health!", r);
        return new NSText::UI(action_buffer);
    case ACTION_DESERT:
        r = random(5, 21);
        player.replenish(0, -r);
        sprintf(action_buffer, "Desert: You have lost %d mana!", r);
        return new NSText::UI(action_buffer);
    case ACTION_CHEST:
        return new NSLockpicking::UI();
    case ACTION_TREASAURE:
        r = random(1, 40);
        player.gold += r;
        sprintf(action_buffer, "Treasaure: You have gained %d gold!", r);
        return new NSText::UI(action_buffer);
    case ACTION_FORWARD:
        Serial.print("FFFF");
        return executeAction(random(ACTION_GRASSLANDS, ACTION_CHEST + 1));
    case ACTION_RESET:
        digitalWrite(Reset_pin, LOW);
    }
    return nullptr;
}