#pragma once
#include "game_data.h"
#include "UIAbstract.h"
#include "sound_functions.h"
#include "ActionManager.h"

class GameAction
{
public:
    char *text;
    byte actionId;
    Cost *cost;

    GameAction()
    {
    }

    ~GameAction()
    {
        delete cost;
    }

    UIAbstract *tryExecute()
    {
        if (player.health > cost->health && player.mana >= cost->mana && player.gold >= cost->gold)
        {
            player.health -= cost->health;
            player.mana -= cost->mana;
            player.gold -= cost->gold;
            soundGood();
            return execute();
        }
        soundBad();
        return nullptr;
    }

    char *generateString(char *buffer)
    {
        char bufferCost[10] = "";
        if (!cost->health && !cost->mana && !cost->gold)
        {
            strcpy(buffer, text);
            strcat(buffer, "\n");
            return buffer;
        }
        sprintf(buffer, "%s $", text);
        if (cost->health != 0)
        {
            sprintf(bufferCost, "%huH", cost->health);
            strcat(buffer, bufferCost);
        }
        if (cost->mana != 0)
        {
            sprintf(bufferCost, "%huM", cost->mana);
            strcat(buffer, bufferCost);
        }
        if (cost->gold != 0)
        {
            sprintf(bufferCost, "%huG", cost->gold);
            strcat(buffer, bufferCost);
        }
        strcat(buffer, "\n");
        Serial.print(buffer);
        return buffer;
    }

protected:
    virtual UIAbstract *execute()
    {
        Serial.print(actionId);
        return executeAction(actionId);
    }
};