#pragma once
#include "definitions.h"

char textBuffer[200];
int lcdIndex = 0, lcdIndexMax = 0;

void setRGBColors(unsigned char redValue, unsigned char greenValue, unsigned char blueValue)
{
    analogWrite(RGBRed_pin, redValue);
    analogWrite(RGBGreen_pin, greenValue);
    analogWrite(RGBBlue_pin, blueValue);
}

void showText()
{
    clearDisplay(WHITE);
    setStr(textBuffer + CHR_PER_ROW * lcdIndex, 0, 0, BLACK);
    updateDisplay();
}

void setText(char *newText)
{
    strcpy(textBuffer, newText);
    lcdIndexMax = ceil((float)strlen(textBuffer) / CHR_PER_ROW);
    lcdIndex = 0;
}

void showActions()
{
    clearDisplay(WHITE);
    setStr(textBuffer, 0, -lcdIndex * CHR_HEIGHT, BLACK);
    setStr(textBuffer, 0, -lcdIndex * CHR_HEIGHT, WHITE, 1);
    updateDisplay();
}

bool scrollText(const int inc)
{
    int newIndex = lcdIndex + inc;
    if (newIndex >= 0 && newIndex < lcdIndexMax)
    {
        Serial.print(newIndex);
        Serial.print('\n');
        lcdIndex = newIndex;
        showText();
        return 1;
    }
    Serial.print(newIndex);
    Serial.print('\n');
    return 0;
}

    void scrollTextFromJoyStick(const int inc)
    {
        if (scrollText(inc))
            soundGood();
        else
            soundBad();
    }