#pragma once
#include "UIAbstract.h"
#include "GameAction.h"
#include "definitions.h"
#include "sound_functions.h"
#include "LCD_Manager.h"
#include "NSText.h"

namespace NSActions
{
    class UI : public UIAbstract
    {
    public:
        GameAction *actions;
        byte actionCount;

        UI(GameAction *actions, byte actionCount) : actions(actions), actionCount(actionCount)
        {
        }

        void OnSelect()
        {
            Serial.print("aaa");
            char lineBuffer[14], textBuffer[200];
            actions[0].generateString(textBuffer);
            Serial.print(textBuffer);
            Serial.print("^\n");
            for (int i = 1; i < actionCount; i++)
                strcat(textBuffer, actions[i].generateString(lineBuffer));
            setText(textBuffer);
        }

        void OnUpdate()
        {
            showActions();
        }

        UIAbstract *OnButtonPress(byte index)
        {
            return actions[lcdIndex].tryExecute();
        }

        void OnJoystickScroll(byte direction)
        {
            scrollTextFromJoyStick(2 * direction - 1);
        }
        
        bool UsesLEDs()
        {
            return true;
        }
    };
}