#pragma once
#include "UIAbstract.h"
#include "definitions.h"
#include "sound_functions.h"
#include "NSText.h"
#include "game_data.h"

namespace NSInfo
{
    enum InfoType
    {
        CHARACTER,
        DEATH
    };

    class UI : public UIAbstract
    {
    public:
        InfoType infoType;

        UI(InfoType infoType) : infoType(infoType)
        {
        }

        void OnSelect()
        {
            OnUpdate();
        }

        void OnUpdate()
        {
            switch (infoType)
            {
            default:
                char textBuffer[200];
                sprintf(textBuffer, "Character\nHP: %d/%d\nMP: %d/%d\nGold: %d\nLockpicks: %d",
                        player.health, player.healthMax,
                        player.mana, player.manaMax,
                        player.gold, player.lockpicks);
                setText(textBuffer);
                showText();
                break;
            }
        }

        bool UsesLEDs()
        {
            return true;
        }
    };
}