#pragma once
#include "UIAbstract.h"
#include "definitions.h"
#include "sound_functions.h"
#include "LCD_Manager.h"

UIAbstract *executeAction(int actionId);

namespace NSText
{
    class UI : public UIAbstract
    {
    public:
        char *text;

        UI(char *text) : text(text)
        {
        }

        virtual void OnSelect()
        {
            setText(text);
        }

        virtual void OnUpdate()
        {
            showText();
        }

        UIAbstract *OnButtonPress(byte index)
        {
            return executeAction(ACTION_FORWARD);
        }

        void OnJoystickScroll(byte direction)
        {
            scrollTextFromJoyStick(2 * direction - 1);
        }

        bool UsesLEDs()
        {
            return true;
        }
    };
}