#pragma once
#include "definitions.h"
#include "game_data.h"
#include "sound_functions.h"
#include "LCD_Manager.h"
#include "GameAction.h"
#include "UIAbstract.h"
#include "NSText.h"
#include "NSLockpicking.h"
#include "NSInfo.h"
#include "NSActions.h"

unsigned long nextScrollTimeStamp = 0, lastPrintTimeStamp = 0;
char buttonPressed = -1;
UIAbstract *menus[MENU_COUNT];
char menuIndex = 0;

void initDefaultMenus()
{
    const byte actionCount = 3;
    menus[0] = new NSText::UI("Move Forward to start your journey!");
    GameAction *a = new GameAction[actionCount];
    a[0].text = "Move Forward";
    a[0].cost = new Cost(0, 0, 0);
    a[0].actionId = ACTION_FORWARD;
    a[1].text = "Heal 10H";
    a[1].cost = new Cost(0, 5, 0);
    a[1].actionId = ACTION_HEAL;
    a[2].text = "Buy pick";
    a[2].cost = new Cost(0, 0, 5);
    a[2].actionId = ACTION_BUY;
    /* 
    a[3].text = "Restart Game";
    a[3].cost = new Cost(0, 0, 0);
    a[3].actionId = ACTION_RESET; */
    menus[1] = new NSActions::UI(a, actionCount);
    menus[2] = new NSInfo::UI(NSInfo::InfoType::CHARACTER);
}

void setUI(UIAbstract *interface)
{
    if (menus[menuIndex] != nullptr)
        delete menus[menuIndex];
    menus[menuIndex] = interface;
}

void onJoystickScroll(const int direction)
{
    if (direction >= 2)
    {
        menuIndex += 2 * direction - 5;
        if (menuIndex < 0)
            menuIndex += MENU_COUNT;
        else if (menuIndex >= MENU_COUNT)
            menuIndex -= MENU_COUNT;
        menus[menuIndex]->OnSelect();
        soundGood();
        nextScrollTimeStamp = millis() + 1000;
    }
    else
    {
        menus[menuIndex]->OnJoystickScroll(direction);
        nextScrollTimeStamp = millis() + 500;
    }
}

void select(byte index)
{
    menuIndex = index;
    lcdIndex = 0;
    menus[menuIndex]->OnSelect();
}

void onUpdate()
{
    menus[menuIndex]->OnUpdate();
}

void changeFrontUI(UIAbstract *interface)
{
    menuIndex = 0;
    setUI(interface);
    lcdIndex = 0;
    menus[menuIndex]->OnSelect();
}

void onButtonPress(const int lcdIndex)
{
    buttonPressed = lcdIndex;
    UIAbstract *ret = menus[menuIndex]->OnButtonPress(lcdIndex);
    if (ret != nullptr)
    {
    Serial.print(((NSText::UI*)ret)->text);
        changeFrontUI(ret);
    }
}