#pragma once
#include <SPI.h>
#include "LCD_Functions.h"

#define CHR_PER_ROW 14
#define ROWS 6
#define CHR_HEIGHT (LCD_HEIGHT/ROWS)
#define CHR_WIDTH (LCD_WIDTH/CHR_PER_ROW)
#define EXCLUDED_ROWS 2
#define JoySW_pin 0
#define Buzz_pin 4
#define JoyX_pin 0
#define JoyY_pin 1
#define Potentiometer_pin 2
#define JoyMinValue 0
#define JoyMaxValue 1024
#define JoyLowThrehold 256
#define JoyHighThrehold 768
#define DIRECTION_UP 0
#define DIRECTION_DOWN 1
#define DIRECTION_LEFT 2
#define DIRECTION_RIGHT 3
#define RGBRed_pin 10
#define RGBGreen_pin 8
#define RGBBlue_pin 3
#define Reset_pin 2
#define Button_pin 12
#define NAME_SIZE 10
#define MENU_COUNT 3

#define ACTION_HEAL 0
#define ACTION_TREASAURE 1
#define ACTION_FORWARD 2
#define ACTION_BUY 3
#define ACTION_GRASSLANDS 10
#define ACTION_RIVER 11
#define ACTION_MOUNTAIN 12
#define ACTION_DESERT 13
#define ACTION_CHEST 14
#define ACTION_RESET -1

#define SYMBOL_EDGE '+'
#define SYMBOL_SELECTED 'O'

byte cheatLockVision = false;

void Serial_printf(const char* format, ...)
{
    char buffer[1024];
    va_list args;
    va_start(args, format);
    vsprintf(buffer, format, args);
    Serial.print(buffer);
    va_end(args);
}